Subject: bug#16433: 24.3.50; find_newline screws up in Rmail buffers

From: Richard Stallman <[email-masked]>
Date: Mon, 13 Jan 2014 14:37:11 -0500

mail-fetch-field gave the wrong result for the X-RMAIL-ATTRIBUTES
field, perhaps because it happened to be last.  It included the
newline after that field in the return value, which is wrong.
Setting cache-long-scans to nil in the Rmail buffer made the
bug go away, so I think the problem is in the newline cache.

I think it would be better to fix the underlying bug, rather than turn
off the cache in Rmail mode.  I suspect that the cache does not handle
Rmail's changes in narrowing.  However, I'm not prepared to debug it
all the way myself.

In GNU Emacs 24.3.50.18 (mips64el-unknown-linux-gnu, GTK+ Version 2.20.1)
 of 2013-12-14 on chiefs-gnewsense
Bzr revision: 115526 [email-masked]
System Description:	gNewSense GNU/Linux 3.0 (parkes)

Configured using:
 `configure 'CFLAGS=-g -O0''

Important settings:
  value of $LANG: en_US.UTF-8
  locale-coding-system: utf-8-unix
  default enable-multibyte-characters: t

Major mode: Change Log

Minor modes in effect:
  bug-reference-mode: t
  diff-auto-refine-mode: t
  shell-dirtrack-mode: t
  gpm-mouse-mode: t
  tooltip-mode: t
  mouse-wheel-mode: t
  tool-bar-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  line-number-mode: t
  transient-mark-mode: t
  abbrev-mode: t

Recent input:
i n g SPC g ESC DEL ESC DEL ESC DEL m a k e SPC c ESC 
DEL ESC DEL e l i m i n a t e SPC t h e SPC p r o b 
l e m SPC o f SPC h o w SPC t o SPC o r g a n i z e 
RET s c DEL o c i e t y . C-o SPC SPC A d v a n c e 
d SPC t e c h n o l o g y SPC m i g h t SPC ESC DEL 
c a n SPC b e SPC g o o d ; SPC A I SPC m i g h t SPC 
b e SPC g o o d RET d e p e n d n t DEL DEL i n g SPC 
o n SPC h o w SPC i t SPC ESC DEL ESC DEL ESC DEL d 
e DEL DEL o n SPC d e t a i l s . SPC SPC B u t SPC 
t h e s e SPC d o n ' t SPC e l i m i n a t e SPC t 
h a t SPC p r o b l e m . ESC a ESC f ESC d ESC d SPC 
t h a t ESC d ESC d C-e DEL SPC r e m a i n s . C-c 
C-c C-d x C-x b RET C-x b C h TAB RET DEL RET C-x k 
RET C-x b C h TAB s TAB RET C-a C-p C-p C-@ C-u C-n 
ESC w ESC x r e p o r t SPC e m a c s SPC b u g RE
T

Recent messages:
Auto save file for draft message exists; consider M-x mail-recover
Auto-saving...done
Auto-saving...done
Auto-saving...done
Sending...
Wrote /home/rms/outgoing/out-30
Sending...done
Expunging deleted messages...done
Mark set
Source file `/home/rms/emacs-bzr/trunk/lisp/mail/emacsbug.el' newer than byte-compiled file

Load-path shadows:
/home/rms/emacs-bzr/trunk/lisp/leim/quail/lao hides /home/rms/emacs-bzr/trunk/lisp/language/lao
/home/rms/emacs-bzr/trunk/lisp/leim/quail/georgian hides /home/rms/emacs-bzr/trunk/lisp/language/georgian
/home/rms/emacs-bzr/trunk/lisp/leim/quail/thai hides /home/rms/emacs-bzr/trunk/lisp/language/thai
/home/rms/emacs-bzr/trunk/lisp/leim/quail/ethiopic hides /home/rms/emacs-bzr/trunk/lisp/language/ethiopic
/home/rms/emacs-bzr/trunk/lisp/leim/quail/japanese hides /home/rms/emacs-bzr/trunk/lisp/language/japanese
/home/rms/emacs-bzr/trunk/lisp/leim/quail/cyrillic hides /home/rms/emacs-bzr/trunk/lisp/language/cyrillic
/home/rms/emacs-bzr/trunk/lisp/leim/quail/indian hides /home/rms/emacs-bzr/trunk/lisp/language/indian
/home/rms/emacs-bzr/trunk/lisp/leim/quail/hebrew hides /home/rms/emacs-bzr/trunk/lisp/language/hebrew
/home/rms/emacs-bzr/trunk/lisp/leim/quail/greek hides /home/rms/emacs-bzr/trunk/lisp/language/greek
/home/rms/emacs-bzr/trunk/lisp/leim/quail/czech hides /home/rms/emacs-bzr/trunk/lisp/language/czech
/home/rms/emacs-bzr/trunk/lisp/leim/quail/slovak hides /home/rms/emacs-bzr/trunk/lisp/language/slovak
/home/rms/emacs-bzr/trunk/lisp/leim/quail/tibetan hides /home/rms/emacs-bzr/trunk/lisp/language/tibetan

Features:
(shadow emacsbug bug-reference cc-langs cl cc-mode cc-fonts cc-guess
cc-menus cc-cmds cc-styles cc-align cc-engine cc-vars cc-defs
smerge-mode whitespace log-view find-func iso-transl mule-util
cal-move cal-menu calendar cal-loaddefs nroff-mode goto-addr view
disp-table enriched conf-mode ffap thingatpt url-parse auth-source
eieio byte-opt bytecomp byte-compile cconv eieio-core gnus-util
password-cache url-vars noutline outline vc-bzr dcl-mode tempo tabify
imenu man jka-compr debug compare-w ispell epa-mail quail rmailsum
diff-mode log-edit easy-mmode pcvs-util add-log vc vc-dispatcher
dired-aux help-mode misearch multi-isearch wid-edit cl-loaddefs cl-lib
rmailout epa derived epg epg-config shell pcomplete grep compile
comint ansi-color dabbrev etags ring parse-time vc-cvs sgml-mode
mailalias qp rmailmm message sendmail format-spec rfc822 mml easymenu
mml-sec mm-decode mm-bodies mm-encode mailabbrev gmm-utils mailheader
mail-parse rfc2231 dired t-mouse package rmailedit rmail rfc2047
rfc2045 ietf-drums mm-util mail-prsvr mail-utils time-date paren
cus-start cus-load advice help-fns tooltip electric uniquify
ediff-hook vc-hooks lisp-float-type mwheel x-win x-dnd tool-bar dnd
fontset image regexp-opt fringe tabulated-list newcomment lisp-mode
prog-mode register page menu-bar rfn-eshadow timer select scroll-bar
mouse jit-lock font-lock syntax facemenu font-core frame cham georgian
utf-8-lang misc-lang vietnamese tibetan thai tai-viet lao korean
japanese hebrew greek romanian slovak czech european ethiopic indian
cyrillic chinese case-table epa-hook jka-cmpr-hook help simple abbrev
minibuffer nadvice loaddefs button faces cus-face macroexp files
text-properties overlay sha1 md5 base64 format env code-pages mule
custom widget hashtable-print-readable backquote make-network-process
dbusbind gfilenotify dynamic-setting system-font-setting
font-render-setting move-toolbar gtk x-toolkit x multi-tty emacs)
[[[ To any NSA and FBI agents reading my email: please consider    ]]]
[[[ whether defending the US Constitution against all enemies,     ]]]
[[[ foreign or domestic, requires you to follow Snowden's example. ]]]

-- 
Dr Richard Stallman
President, Free Software Foundation
51 Franklin St
Boston MA 02110
USA
www.fsf.org  www.gnu.org
Skype: No way! That's nonfree (freedom-denying) software.
  Use Ekiga or an ordinary phone call.